Index: modules/RecoPuFilter.cc
===================================================================
--- modules/RecoPuFilter.cc	(revision 5198eed84d5bab7e6b16bdfdcb39ef98decf0486)
+++ modules/RecoPuFilter.cc	(revision 5198eed84d5bab7e6b16bdfdcb39ef98decf0486)
@@ -0,0 +1,105 @@
+/*
+ *  Delphes: a framework for fast simulation of a generic collider experiment
+ *  Copyright (C) 2012-2014  Universite catholique de Louvain (UCL), Belgium
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/*  \class RecoPuFilter
+ *
+ *  Removes particles with RecoPU flag = true.
+ *  Input collection needs to pass by TrackPileUpSubtractor first)
+ *
+ *  \author M. Selvaggi
+ *
+ */
+
+#include "modules/RecoPuFilter.h"
+
+#include "classes/DelphesClasses.h"
+#include "classes/DelphesFactory.h"
+#include "classes/DelphesFormula.h"
+
+#include "ExRootAnalysis/ExRootResult.h"
+#include "ExRootAnalysis/ExRootFilter.h"
+#include "ExRootAnalysis/ExRootClassifier.h"
+
+#include "TMath.h"
+#include "TString.h"
+#include "TFormula.h"
+#include "TRandom3.h"
+#include "TObjArray.h"
+#include "TDatabasePDG.h"
+#include "TLorentzVector.h"
+
+#include <algorithm>
+#include <stdexcept>
+#include <iostream>
+#include <sstream>
+
+using namespace std;
+
+//------------------------------------------------------------------------------
+
+RecoPuFilter::RecoPuFilter() :
+  fItInputArray(0)
+{
+}
+
+//------------------------------------------------------------------------------
+
+RecoPuFilter::~RecoPuFilter()
+{
+}
+
+//------------------------------------------------------------------------------
+
+void RecoPuFilter::Init()
+{
+
+  ExRootConfParam param;
+  Size_t i, size;
+
+  // import input array
+  fInputArray = ImportArray(GetString("InputArray", "Delphes/allParticles"));
+  fItInputArray = fInputArray->MakeIterator();
+
+  // create output array
+  fOutputArray = ExportArray(GetString("OutputArray", "filteredParticles"));
+}
+
+//------------------------------------------------------------------------------
+
+void RecoPuFilter::Finish()
+{
+  if(fItInputArray) delete fItInputArray;
+}
+
+//------------------------------------------------------------------------------
+
+void RecoPuFilter::Process()
+{
+  Candidate *candidate;
+  Int_t pdgCode;
+  Bool_t pass;
+  Double_t pt;
+
+  fItInputArray->Reset();
+  while((candidate = static_cast<Candidate*>(fItInputArray->Next())))
+  {
+    if(candidate->IsRecoPU) continue;
+    fOutputArray->Add(candidate);
+  }
+}
+
Index: modules/RecoPuFilter.h
===================================================================
--- modules/RecoPuFilter.h	(revision 5198eed84d5bab7e6b16bdfdcb39ef98decf0486)
+++ modules/RecoPuFilter.h	(revision 5198eed84d5bab7e6b16bdfdcb39ef98decf0486)
@@ -0,0 +1,61 @@
+/*
+ *  Delphes: a framework for fast simulation of a generic collider experiment
+ *  Copyright (C) 2012-2014  Universite catholique de Louvain (UCL), Belgium
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+//------------------------------------------------------------------------------
+
+#ifndef RecoPuFilter_h
+#define RecoPuFilter_h
+
+/** \class RecoPuFilter
+ *
+ *  Removes particles with RecoPU flag = true.
+ *  Input collection needs to pass by TrackPileUpSubtractor first)
+ *
+ *  \author M. Selvaggi
+ *
+ */
+
+#include "classes/DelphesModule.h"
+#include <vector>
+
+class TIterator;
+class TObjArray;
+
+class RecoPuFilter: public DelphesModule
+{
+public:
+
+  RecoPuFilter();
+  ~RecoPuFilter();
+
+  void Init();
+  void Process();
+  void Finish();
+
+private:
+
+  TIterator *fItInputArray; //!
+
+  const TObjArray *fInputArray; //!
+
+  TObjArray *fOutputArray; //!
+
+  ClassDef(RecoPuFilter, 1)
+};
+
+#endif