Index: cards/delphes_card_CLICdet.tcl
===================================================================
--- cards/delphes_card_CLICdet.tcl	(revision 5953e02f68d23a0304b6289edd9f0e861e0089af)
+++ cards/delphes_card_CLICdet.tcl	(revision 5554fa9666ccad7ce69d6fb2661da9aa124449e5)
@@ -228,10 +228,10 @@
 
     set EfficiencyFormula {
-(abs(eta) > 2.54) * (0.000) +
-(energy >= 100) * (abs(eta) < 2.54)  * (1.000) +
-(energy < 100 && energy >= 10) * (abs(eta) <=2.54 && abs(eta) > 2.34)  * (0.994) +
-(energy < 100 && energy >= 10) * (abs(eta) <= 2.34) * (1.000) +
-(energy < 10  && energy >= 1) * (abs(eta) <= 2.54 && abs(eta) > 0.55 ) * (0.000) +
-(energy < 10  && energy >= 1) * (abs(eta) <= 0.55 ) * (1.000) 
+	(abs(eta) > 2.54) * (0.000) +
+	(energy >= 100) * (abs(eta) < 2.54)  * (1.000) +
+	(energy < 100 && energy >= 10) * (abs(eta) <=2.54 && abs(eta) > 2.34)  * (0.994) +
+	(energy < 100 && energy >= 10) * (abs(eta) <= 2.34) * (1.000) +
+	(energy < 10  && energy >= 1) * (abs(eta) <= 2.54 && abs(eta) > 0.55 ) * (0.000) +
+	(energy < 10  && energy >= 1) * (abs(eta) <= 0.55 ) * (1.000) 
     }
 }
@@ -248,15 +248,15 @@
     # Current full simulation with CLICdet provides for electrons:
     set EfficiencyFormula {
-		(pt <= 1)                                                               * (0.000) +
-		(abs(eta) > 2.54)                                                       * (0.000) +
-		(energy > 100)                 * (abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (0.993) +
-		(energy > 100)                 * (abs(eta) <= 2.44 && abs(eta) > 2.34 ) * (0.997) +
-		(energy > 100)                 * (abs(eta) <= 2.34  )                   * (1.000) +
-		(energy <= 100 && energy > 10) * (abs(eta) <= 2.54 && abs(eta) > 2.17 ) * (0.998) +
-		(energy <= 100 && energy > 10) * (abs(eta) <= 2.17)                     * (1.000) +
-		(energy <= 10 && energy > 1)   * (abs(eta) > 2.34 )                     * (0.000) +
-		(energy <= 10 && energy > 1)   * (abs(eta) <= 2.34 && abs(eta) > 0.76 ) * (0.997) +
-		(energy <= 10 && energy > 1)   * (abs(eta) <= 0.76)                     * (0.999)
-     }
+	(pt <= 1)                                                               * (0.000) +
+	(abs(eta) > 2.54)                                                       * (0.000) +
+	(energy > 100)                 * (abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (0.993) +
+	(energy > 100)                 * (abs(eta) <= 2.44 && abs(eta) > 2.34 ) * (0.997) +
+	(energy > 100)                 * (abs(eta) <= 2.34  )                   * (1.000) +
+	(energy <= 100 && energy > 10) * (abs(eta) <= 2.54 && abs(eta) > 2.17 ) * (0.998) +
+	(energy <= 100 && energy > 10) * (abs(eta) <= 2.17)                     * (1.000) +
+	(energy <= 10 && energy > 1)   * (abs(eta) > 2.34 )                     * (0.000) +
+	(energy <= 10 && energy > 1)   * (abs(eta) <= 2.34 && abs(eta) > 0.76 ) * (0.997) +
+	(energy <= 10 && energy > 1)   * (abs(eta) <= 0.76)                     * (0.999)
+    }
 }
 
@@ -292,4 +292,5 @@
 
     # Resolution given in dpT/pT.
+    # CLICdet internal studies
     set ResolutionFormula {
 	(abs(eta) < 2.66 && abs(eta) >= 2.03 ) * sqrt( 8.56036e-05^2 * pt^2 +0.0148987^2    ) +
@@ -311,4 +312,5 @@
 
     # Resolution given in dpT/pT.
+    # CLICdet internal studies
     set ResolutionFormula {
 	(abs(eta) < 2.66 && abs(eta) >= 2.03 ) * sqrt( 8.62283e-05^2 * pt^2  + 0.0177556^2   ) +
@@ -330,4 +332,6 @@
 
     # Resolution given in dpT/pT.
+
+    # CLICdet internal studies
     set ResolutionFormula {
 
@@ -455,5 +459,5 @@
 
     # set ECalResolutionFormula {resolution formula as a function of eta and energy}
-
+    # not from CLICdet
     set ResolutionFormula { (abs(eta) <= 3.0)                   * sqrt(energy^2*0.01^2 + energy*0.15^2) }
 
@@ -542,9 +546,8 @@
 
     # set HCalResolutionFormula {resolution formula as a function of eta and energy}
-
-	# set ResolutionFormula {                  (abs(eta) <= 3.0) * sqrt(energy^2*0.015^2 + energy*0.50^2)}
-	set ResolutionFormula { (abs(eta)< 0.8) * sqrt(1.48^2  + 0.251^2*energy  + 0.0537^2*energy^2) +
+    #CLICdet internal studies
+    set ResolutionFormula { (abs(eta)< 0.8) * sqrt(1.48^2  + 0.251^2*energy  + 0.0537^2*energy^2) +
 	(abs(eta)>= 0.8 && abs(eta)<=3) * sqrt( 1.09^2 + 0.321^2*energy + 0.0517^2*energy^2  )}
-
+    
 }
 
@@ -601,5 +604,4 @@
 }
 
-##here
 
 ###################
@@ -614,15 +616,7 @@
 
     # efficiency formula for photons
-	# including converted photons
-	#0.94 for |costheta| < 0.6, i.e. |eta|< 0.7
-	#0.9 for |costheta| > 0.6, i.e. |eta|>0.7 but smaller than 3
-
-
+    # current full simulation of CLICdet yields:
 	set EfficiencyFormula {(abs(eta) < 0.7)*(0.94) + (abs(eta) >=0.7 && abs(eta) <=3.0) * (0.9)	}
-	#old:
-    #set EfficiencyFormula {                                      (pt <= 10.0) * (0.00) +
-	#(abs(eta) <= 1.5) * (pt > 10.0)  * (0.95) +
-	#(abs(eta) > 1.5 && abs(eta) <= 2.5) * (pt > 10.0)  * (0.95) +
-	#(abs(eta) > 2.5)                                   * (0.00)}
+
 }
 
@@ -691,11 +685,6 @@
 
     # efficiency formula for muons
+    # current full simulation of CLICdet yields:
 	set EfficiencyFormula {(energy  < 50 )*(0.98) + (energy>=50) *(0.999)}
-    #set EfficiencyFormula {                                      (pt <= 10.0)               * (0.00) +
-	#(abs(eta) <= 1.5) * (pt > 10.0 && pt <= 1.0e3) * (0.95) +
-	#(abs(eta) <= 1.5) * (pt > 1.0e3)               * (0.95 * exp(0.5 - pt*5.0e-4)) +
-	#(abs(eta) > 1.5 && abs(eta) <= 2.4) * (pt > 10.0 && pt <= 1.0e3) * (0.95) +
-	#(abs(eta) > 1.5 && abs(eta) <= 2.4) * (pt > 1.0e3)               * (0.95 * exp(0.5 - pt*5.0e-4)) +
-	#(abs(eta) > 2.4)                                                 * (0.00)}
 }
 
@@ -749,16 +738,4 @@
 }
 
-
-#
-#module PdgCodeFilter EFlowFilter {
-#    set InputArray EFlowMerger/eflow
-#    set OutputArray eflow
-#    
-#    add PdgCode {11}
-#    add PdgCode {-11}
-#    add PdgCode {13}
-#    add PdgCode {-13}
-#}
-
 #################
 # Neutrino Filter
@@ -827,5 +804,5 @@
 }
 
-source CLICdet_JetReco.tcl
+source CLICdet/CLICdet_JetReco.tcl
 
 
@@ -847,5 +824,5 @@
 ########################
 
-source CLICdet_JetFlavorAssociation.tcl
+source  CLICdet/CLICdet_JetFlavorAssociation.tcl
 
 ###########
@@ -854,5 +831,5 @@
 # based on CLICdp-Note-2014-002    
 
-source CLICdet_BTagging.tcl
+source  CLICdet/CLICdet_BTagging.tcl
 
 