Index: cards/delphes_card_ATLAS.tcl
===================================================================
--- cards/delphes_card_ATLAS.tcl	(revision ff37d757a682e9b5fe1ed0f8169abd9f4d4b5fa7)
+++ cards/delphes_card_ATLAS.tcl	(revision 6153fb0e255bcf20b19852b0a99e4fdc576ac991)
@@ -34,4 +34,6 @@
 
   JetEnergyScale
+  
+  JetFlavorAssociation
 
   BTagging
@@ -481,4 +483,21 @@
 }
 
+########################
+# Jet Flavor Association
+########################
+
+module JetFlavorAssociation JetFlavorAssociation {
+  
+  set PartonInputArray Delphes/partons
+  set ParticleInputArray Delphes/allParticles
+  set ParticleLHEFInputArray Delphes/allParticlesLHEF
+  set JetInputArray JetEnergyScale/jets
+  
+  set DeltaR 0.5
+  set PartonPTMin 1.0
+  set PartonEtaMax 2.5
+
+}
+
 ###########
 # b-tagging
@@ -486,14 +505,7 @@
 
 module BTagging BTagging {
-  set PartonInputArray Delphes/partons
   set JetInputArray JetEnergyScale/jets
 
   set BitNumber 0
-
-  set DeltaR 0.5
-
-  set PartonPTMin 1.0
-
-  set PartonEtaMax 2.5
 
   # add EfficiencyFormula {abs(PDG code)} {efficiency formula as a function of eta and pt}
@@ -516,4 +528,8 @@
                               (abs(eta) > 2.5)                                  * (0.000)}
 }
+
+#############
+# tau-tagging
+#############
 
 module TauTagging TauTagging {
Index: cards/delphes_card_ATLAS_PileUp.tcl
===================================================================
--- cards/delphes_card_ATLAS_PileUp.tcl	(revision ff37d757a682e9b5fe1ed0f8169abd9f4d4b5fa7)
+++ cards/delphes_card_ATLAS_PileUp.tcl	(revision 6153fb0e255bcf20b19852b0a99e4fdc576ac991)
@@ -42,4 +42,6 @@
 
   MissingET
+  
+  JetFlavorAssociation
 
   BTagging
@@ -602,4 +604,21 @@
 }
 
+########################
+# Jet Flavor Association
+########################
+
+module JetFlavorAssociation JetFlavorAssociation {
+  
+  set PartonInputArray Delphes/partons
+  set ParticleInputArray Delphes/allParticles
+  set ParticleLHEFInputArray Delphes/allParticlesLHEF
+  set JetInputArray JetEnergyScale/jets
+  
+  set DeltaR 0.5
+  set PartonPTMin 1.0
+  set PartonEtaMax 2.5
+
+}
+
 ###########
 # b-tagging
@@ -607,14 +626,7 @@
 
 module BTagging BTagging {
-  set PartonInputArray Delphes/partons
   set JetInputArray JetEnergyScale/jets
 
   set BitNumber 0
-
-  set DeltaR 0.5
-
-  set PartonPTMin 1.0
-
-  set PartonEtaMax 2.5
 
   # add EfficiencyFormula {abs(PDG code)} {efficiency formula as a function of eta and pt}
@@ -637,4 +649,8 @@
                               (abs(eta) > 2.5)                                  * (0.000)}
 }
+
+#############
+# tau-tagging
+#############
 
 module TauTagging TauTagging {
Index: cards/delphes_card_CMS.tcl
===================================================================
--- cards/delphes_card_CMS.tcl	(revision ff37d757a682e9b5fe1ed0f8169abd9f4d4b5fa7)
+++ cards/delphes_card_CMS.tcl	(revision 6153fb0e255bcf20b19852b0a99e4fdc576ac991)
@@ -34,4 +34,6 @@
 
   JetEnergyScale
+
+  JetFlavorAssociation
 
   BTagging
@@ -464,6 +466,4 @@
 
 
-
-
 ############
 # Jet finder
@@ -495,4 +495,21 @@
 }
 
+########################
+# Jet Flavor Association
+########################
+
+module JetFlavorAssociation JetFlavorAssociation {
+  
+  set PartonInputArray Delphes/partons
+  set ParticleInputArray Delphes/allParticles
+  set ParticleLHEFInputArray Delphes/allParticlesLHEF
+  set JetInputArray JetEnergyScale/jets
+  
+  set DeltaR 0.5
+  set PartonPTMin 1.0
+  set PartonEtaMax 2.5
+
+}
+
 ###########
 # b-tagging
@@ -500,14 +517,7 @@
 
 module BTagging BTagging {
-  set PartonInputArray Delphes/partons
   set JetInputArray JetEnergyScale/jets
 
   set BitNumber 0
-
-  set DeltaR 0.5
-
-  set PartonPTMin 1.0
-
-  set PartonEtaMax 2.5
 
   # add EfficiencyFormula {abs(PDG code)} {efficiency formula as a function of eta and pt}
@@ -531,4 +541,8 @@
                               (abs(eta) > 2.5)                                  * (0.000)}
 }
+
+#############
+# tau-tagging
+#############
 
 module TauTagging TauTagging {
Index: cards/delphes_card_CMS_PileUp.tcl
===================================================================
--- cards/delphes_card_CMS_PileUp.tcl	(revision ff37d757a682e9b5fe1ed0f8169abd9f4d4b5fa7)
+++ cards/delphes_card_CMS_PileUp.tcl	(revision 6153fb0e255bcf20b19852b0a99e4fdc576ac991)
@@ -43,4 +43,6 @@
 
   MissingET
+  
+  JetFlavorAssociation
 
   BTagging
@@ -642,4 +644,21 @@
 }
 
+########################
+# Jet Flavor Association
+########################
+
+module JetFlavorAssociation JetFlavorAssociation {
+  
+  set PartonInputArray Delphes/partons
+  set ParticleInputArray Delphes/allParticles
+  set ParticleLHEFInputArray Delphes/allParticlesLHEF
+  set JetInputArray JetEnergyScale/jets
+  
+  set DeltaR 0.5
+  set PartonPTMin 1.0
+  set PartonEtaMax 2.5
+
+}
+
 ###########
 # b-tagging
@@ -647,14 +666,7 @@
 
 module BTagging BTagging {
-  set PartonInputArray Delphes/partons
   set JetInputArray JetEnergyScale/jets
 
   set BitNumber 0
-
-  set DeltaR 0.5
-
-  set PartonPTMin 1.0
-
-  set PartonEtaMax 2.5
 
   # add EfficiencyFormula {abs(PDG code)} {efficiency formula as a function of eta and pt}
@@ -678,4 +690,8 @@
                               (abs(eta) > 2.5)                                  * (0.000)}
 }
+
+#############
+# tau-tagging
+#############
 
 module TauTagging TauTagging {